#pragma	once

//O[oϐ̐錾
double	a;//̌W
double	t_start,t_finish;
double	x_start;
double	v_start;
double	d_t;//ï߻
FILE	*fxdata;
int	algorithm;
Vector	(*algo[4])(Vector	X,	double	t);

//֐̐錾`
//
double	d2x_dt2(	double	x,	double	t){
	return	-	a	*	x;
}
//͉
double	real_x(	double	t){
	return	sqrt(1/a)	*	sin(	sqrt(a)	*	t	);
}
double	real_v(	double	t){
	return	cos(	sqrt(a)	*	t	);
}
//l
Vector	euler_dX(Vector	X,	double	t){
	return	Vector(	X[1],	d2x_dt2(	X[0],	t	)	);
}
Vector	algo1_dX(Vector	X,	double	t){
	double	k1,k2;
	k1	=	d2x_dt2(	X[0],	t);
	k2	=	d2x_dt2(	X[0]+d_t*k1,	t+d_t);
	return	Vector(	X[1],	k1/2	+	k2/2);
}
Vector	algo2_dX(Vector	X,	double	t){
	double	k1,k2;
	k1	=	d2x_dt2(	X[0],	t);
	k2	=	d2x_dt2(	X[0]+d_t/2*k1,	t+d_t/2);
	return	Vector(	X[1],	k2);
}
Vector	Runge_dX(Vector	X,	double	t){
	double	k1,k2,k3,k4;
	k1	=	d2x_dt2(	X[0],	t);
	k2	=	d2x_dt2(	X[0]+d_t/2*k1,	t+d_t/2);
	k3	=	d2x_dt2(	X[0]+d_t/2*k2,	t+d_t/2);
	k4	=	d2x_dt2(	X[0]+d_t*k3,	t+d_t);
	return	Vector(	X[1],	(k1	+	2*k2	+	2*k3	+	k4	)/6	);
}

//ϕ
void	integral(){
	Vector	X(	x_start,	v_start);
	Vector	temp;
	printf(	"t		");
	printf(	"͉	");
	printf(	"͉	");
	printf(	"l	");
	printf(	"l	");
	printf(	"덷	");
	printf(	"덷	");
	printf(	"\n");

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"͉	");
	fprintf(	fxdata,	"͉	");
	fprintf(	fxdata,	"l	");
	fprintf(	fxdata,	"l	");
	fprintf(	fxdata,	"덷	");
	fprintf(	fxdata,	"덷	");
	fprintf(	fxdata,	"\n");
	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){
		printf(	"%f	",	t);
		printf(	"%f	",	real_x(t));
		printf(	"%f	",	real_v(t));
		printf(	"%f	",	X[0]);
		printf(	"%f	",	X[1]);
		printf(	"%f	",	fabs(real_x(t)	-	X[0])	);
		printf(	"%f	",	fabs(real_v(t)	-	X[1])	);
		printf(	"\n");

		fprintf(	fxdata,	"%f	",	t);
		fprintf(	fxdata,	"%f	",	real_x(t));
		fprintf(	fxdata,	"%f	",	real_v(t));
		fprintf(	fxdata,	"%f	",	X[0]);
		fprintf(	fxdata,	"%f	",	X[1]);
		fprintf(	fxdata,	"%f	",	fabs(real_x(t)	-	X[0])	);
		fprintf(	fxdata,	"%f	",	fabs(real_v(t)	-	X[1])	);
		fprintf(	fxdata,	"\n");
		temp	=	algo[algorithm-1](X,t);
		temp	*=	d_t;
		X	+=	temp;
		
	}
}
void	integral_all(){
	Vector	X[4];
	for(	int	i=0;	i	<	4;	i++){
		X[i]	=	Vector(	x_start,	v_start);
	};
	Vector	temp;

	fprintf(	fxdata,	"t	");
	fprintf(	fxdata,	"͉		");
	fprintf(	fxdata,	"IC[@				");
	fprintf(	fxdata,	"ASYP				");
	fprintf(	fxdata,	"ASYQ				");
	fprintf(	fxdata,	"ÓTIQNb^@");
	fprintf(	fxdata,	"\n");

	fprintf(	fxdata,	"	");
	//
	fprintf(	fxdata,	"	");
	fprintf(	fxdata,	"	");
	for(	int	i=0;	i<4;	i++){
		fprintf(	fxdata,	"	");
		fprintf(	fxdata,	"	");
		fprintf(	fxdata,	"덷	");
		fprintf(	fxdata,	"덷	");
	}
	fprintf(	fxdata,	"\n");

	for(	double	t	=	t_start;	t	<	t_finish	+	d_t	/	2;	t	+=	d_t){
		printf(	"%f	",	t);
		printf(	"%f	",	real_x(t));
		printf(	"%f	",	real_v(t));
		fprintf(	fxdata,	"%f	",	t);
		fprintf(	fxdata,	"%f	",	real_x(t));
		fprintf(	fxdata,	"%f	",	real_v(t));
		for(	int	i=0;	i	<	4;	i++){
			printf(	"%f	",	X[i][0]);
			printf(	"%f	",	X[i][1]);
			printf(	"%f	",	fabs(real_x(t)	-	X[i][0])	);
			printf(	"%f	",	fabs(real_v(t)	-	X[i][1])	);
			fprintf(	fxdata,	"%f	",	X[i][0]);
			fprintf(	fxdata,	"%f	",	X[i][1]);
			fprintf(	fxdata,	"%f	",	fabs(real_x(t)	-	X[i][0])	);
			fprintf(	fxdata,	"%f	",	fabs(real_v(t)	-	X[i][1])	);
			temp	=	algo[i](X[i],t);
			temp	*=	d_t;
			X[i]	+=	temp;
		}
		printf(	"\n");
		fprintf(	fxdata,	"\n");
	}		
}


//ϕ@̑I
void	select_algorithm(){
	//ϐ錾
	algorithm	=	0;
	char	temp[256];	
	//ϕ@I
	while(	(algorithm	<	1)	|	(5	<	algorithm)	){
		printf("ϕ@IĂB\n");
		printf("@@1FIC[@\n");
		printf("@@2FASYP(a=1)\n");
		printf("@@3FASYQ(a=1/2)\n");
		printf("@@4FÓTIQNb^@\n");
		printf("@@5FׂĂ̕@ōs\n");
		printf("ԁHF");
		gets(	temp	);
		algorithm	=	atoi(	temp);
		switch(	algorithm	){
			case	1:
			fprintf(	fxdata,	"IC[@\n");
			break;
			case	2:
			fprintf(	fxdata,	"ASYP(a=1)\n");
			break;
			case	3:
			fprintf(	fxdata,	"ASYQ(a=1/2)\n");
			break;
			case	4:
			fprintf(	fxdata,	"ÓTIQNb^@\n");
			break;
			case	5:
			fprintf(	fxdata,	"ׂĂ̕@\n");
			break;
		}
	}
}

//ϕ̐ݒ
void	establishment(){
	//ϐ錾
	char	temp[256];
	
	//ϐ̓		
	cout	<<	"̌W\n";
	fprintf(	fxdata,	"W\n");

	cout	<<	"  a : ";
	cin	>>	a;
	fprintf(	fxdata,	"a	%f\n",	a);

	cout	<<	"l\n";
	fprintf(	fxdata,	"l\n");
	
	cout	<<	"  t : ";
	cin	>>	t_start;
	fprintf(	fxdata,	"t	%f\n",	t_start);
	
	cout	<<	"  x : ";
	cin	>>	x_start;
	fprintf(	fxdata,	"x	%f\n",	x_start);

	cout	<<	"  v : ";
	cin	>>	v_start;
	fprintf(	fxdata,	"v	%f\n",	v_start);
		
	cout	<<	"Il\n";
	fprintf(	fxdata,	"Il\n");
	
	cout	<<	"  t : ";
	cin	>>	t_finish;
	fprintf(	fxdata,	"t	%f\n",	t_finish);
	
	cout	<<	"XebvTCY\n";
	fprintf(	fxdata,	"XebvTCY\n");
	
	cout	<<	"  h : ";
	cin	>>	d_t;
	fprintf(	fxdata,	"h	%f\n",	d_t);
}